package cern.ws.demo;

import java.awt.*;
import java.awt.event.MouseEvent;

import javax.swing.*;

/**
 *  Message Monitor User Interface
 *
 *@author     dmathies
 *@created    August 15, 2003
 */
public class MessageMonitorFrame extends JFrame
{
    private JLabel messageText = new JLabel();
    private CardLayout cardLayout1 = new CardLayout();
    private ImagePanel image = new ImagePanel();


    /**
     *  Constructor for the MessageMonitorFrame object
     */
    public MessageMonitorFrame()
    {
        try
        {
            jbInit();
        }
        catch (Exception e)
        {
            e.printStackTrace();
        }

    }


    /**
     *  Sets the message displayed in the GUI
     *
     *@param  name    The new message value
     *@param  colour  The new message value
     */
    public void setMessage(String name, String colour)
    {
        if (name.equalsIgnoreCase("bill") && colour.equalsIgnoreCase("blue"))
        {
            dispose();
            setUndecorated(true);
            GraphicsEnvironment.getLocalGraphicsEnvironment().getDefaultScreenDevice().setFullScreenWindow(this);
            image.setIcon(new ImageIcon("images/blue.gif"));
            cardLayout1.show(this.getContentPane(), "2");
            show();
        }
        else
        {
            if (isUndecorated())
            {
                dispose();
                setUndecorated(false);
                GraphicsEnvironment.getLocalGraphicsEnvironment().getDefaultScreenDevice().setFullScreenWindow(null);
                cardLayout1.show(this.getContentPane(), "1");
                show();
            }
            if (name.equalsIgnoreCase("reset"))
            {
                cardLayout1.show(this.getContentPane(), "1");
                messageText.setText("Message Monitor");
                messageText.setBackground(Color.lightGray);
                messageText.setForeground(Color.black);
                repaint();
            }
            else if (name.equalsIgnoreCase("adam"))
            {
                image.setIcon(new ImageIcon("images/adam.jpg"));
                cardLayout1.show(this.getContentPane(), "2");
                //image.repaint();
                repaint();
            }
            else if (name.equalsIgnoreCase("thomas"))
            {
                image.setIcon(new ImageIcon("images/thomas.jpg"));
                cardLayout1.show(this.getContentPane(), "2");
                repaint();
            }
            else
            {
                cardLayout1.show(this.getContentPane(), "1");
                messageText.setText("Hello " + name);
                messageText.setBackground(ColorDecoder.getColorByName(colour));
            }
        }

    }

    private void jbInit() throws Exception
    {
        this.getContentPane().setLayout(cardLayout1);
        this.setSize(new Dimension(400, 300));
        this.setTitle("WebService Monitor");
        this.addMouseListener(
            new java.awt.event.MouseAdapter()
            {
                public void mouseClicked(MouseEvent e)
                {
                    this_mouseClicked(e);
                }
            });
        messageText.setText("Message Monitor");
        messageText.setOpaque(true);
        messageText.setHorizontalAlignment(SwingConstants.CENTER);
        messageText.setHorizontalTextPosition(SwingConstants.CENTER);
        messageText.setFont(new Font("Dialog", 0, 48));
        this.getContentPane().add(image, "2");
        this.getContentPane().add(messageText, "1");
        cardLayout1.show(this.getContentPane(), "1");
    }


    private void this_mouseClicked(MouseEvent e)
    {
        if (isUndecorated())
        {
            setMessage("", "lightGray");
        }
    }
}
